#include "descriptor/descriptor.h"

int main(void) {

  ITEM	nero, bianco, blu, rosso, vetro, specchio, steel, arancio, verde, grigio, obsGlass;
  ITEM	carrozzeria, vetri, pezzi_neri, pezzi_rossi, fari_anteriori, griglia_anteriore_fari,
		griglia_paraurti_anteriore_sotto, vetri_fari_anteriori, frecce;
  ITEM    pneumatico_destro_anteriore, pneumatico_sinistro_anteriore, 
		pneumatico_destro_posteriore, pneumatico_sinistro_posteriore;
  ITEM    cerchio_completo_destro_anteriore, cerchio_completo_sinistro_anteriore, 	
		cerchio_completo_destro_posteriore, cerchio_completo_sinistro_posteriore, 
		bulloni_cerchione_destro_anteriore, bulloni_cerchione_destro_posteriore,
          bulloni_cerchione_sinistro_anteriore, bulloni_cerchione_sinistro_posteriore,  
		pinza_disco_freno_destro_anteriore, pinza_disco_freno_destro_posteriore,
		pinza_disco_freno_sinistro_anteriore, pinza_disco_freno_sinistro_posteriore,	
		interni, marmitte, targa, stemma;
  ITEM    specchio_sx, specchio_dx;
  ITEM    strada, prato, parcheggi, muretto;
  ITEM	scene;
  

  set_background(0.676,0.861,0.953,TRUE);
  set_ambient_light(1,1,1,0.7);
  create_point_light(16.16,15.90,9.39,1,1,1,3.89,20, "light1");
  create_point_light(12,-12,9,1,1,1,4,20, "light2");
  create_point_light(2.33,-0.25,16.21,1,1,1,3.89,25, "light3");

  /*** ATTRIBUTE blu ***/
  blu = create_attribute("blu");
  set_color(blu,0,0,1,0.5,0.5);
  set_reflectivity(blu,0.3,10);

  /*** ATTRIBUTE nero ***/
  nero = create_attribute("nero");
  set_color(nero,0,0,0,0,0);
  //set_reflectivity(nero,0.1,0.2);
 
  /*** ATTRIBUTE rosso ***/
  rosso = create_attribute("rosso");
  set_color(rosso, 0.6, 0, 0, 1.0, 0.5);
  
  /*** ATTRIBUTE arancio ***/
  arancio = create_attribute("arancio");
  set_color(arancio, 1, 0.5, 0.0, 1.0, 0.5);
  
  /*** ATTRIBUTE verde ***/
  verde = create_attribute("verde");
  set_color(verde,0,0.174,0.095,0.5,0.6);
  //set_reflectivity(verde,0.17,15);

  /*** ATTRIBUTE grigio ***/
  grigio = create_attribute("grigio");
  set_color(grigio, 0.5, 0.5, 0.5, 0.5, 0.5);

  /*** ATTRIBUTE glass ***/
  vetro = create_attribute("glass");
  set_color(vetro,1.0,1.0,1.0,0.5,0.5);
  set_reflectivity(vetro,0.24,2);
  set_transparency(vetro,0.87,0.68,1,1.2);

   /*** ATTRIBUTE bianco ***/
  bianco = create_attribute("bianco");
  set_color(bianco,1.0,1.0,1.0,0.5,0.5);
  set_reflectivity(bianco,0.24,2);
  
  /*** ATTRIBUTE specchio ***/
  specchio = create_attribute("specchio");
  set_color(specchio,0.3,0.3,0.3,1,0);
  set_reflectivity(specchio,1.0,128);

  /*** ATTRIBUTE steel ***/
  steel = create_attribute("steel");
  set_color(steel,0.3,0.3,0.3,0.5,1);
  set_reflectivity(steel,0.3,128);

  /*** ATTRIBUTE obsGlass ***/
  obsGlass = create_attribute("obsGlass");
  set_color(obsGlass,0.04,0.06,0.07,0.5,0.5);
  set_reflectivity(obsGlass,0.24,2);
  set_transparency(obsGlass,0.19,0.08,1,1.2);


  carrozzeria = read_obj("carrozzeria.obj", "carrozzeria");
  set_attribute(carrozzeria, blu);
  
  vetri = read_obj("vetri.obj", "vetri");
  set_attribute(vetri, vetro);

  pezzi_neri = read_obj("pezzi_neri.obj", "pezzi_neri");
  set_attribute(pezzi_neri, nero);
  
  pezzi_rossi = read_obj("pezzi_rossi.obj", "pezzi_rossi");
  set_attribute(pezzi_rossi, rosso);
  
  interni = read_nurbs("interni.db");  
  set_attribute(interni, nero);

  specchio_dx = read_nurbs("vetro_specchietto_destro_ok.db");
  set_attribute(specchio_dx, specchio);
  specchio_sx = read_nurbs("vetro_specchietto_sinistro_ok.db");
  set_attribute(specchio_sx, specchio);

  cerchio_completo_destro_anteriore = read_obj("ruota_destra_anteriore.obj", "cerchio_completo_destro_anteriore");
  set_attribute(cerchio_completo_destro_anteriore, steel);

  cerchio_completo_destro_posteriore = read_obj("ruota_destra_posteriore.obj", "cerchio_completo_destro_posteriore");
  set_attribute(cerchio_completo_destro_posteriore, steel);

  cerchio_completo_sinistro_anteriore = read_obj("ruota_sinistra_anteriore.obj", "cerchio_completo_sinistro_anteriore");
  set_attribute(cerchio_completo_sinistro_anteriore, steel);

  cerchio_completo_sinistro_posteriore = read_obj("ruota_sinistra_posteriore.obj", "cerchio_completo_sinistro_posteriore");
  set_attribute(cerchio_completo_sinistro_posteriore, steel);

  bulloni_cerchione_destro_anteriore = read_obj("bulloni_cerchione_destro_anteriore.obj", "bulloni_cerchione_destro_anteriore");
  set_attribute(bulloni_cerchione_destro_anteriore, obsGlass);

  bulloni_cerchione_destro_posteriore = read_obj("bulloni_cerchione_destro_posteriore.obj", "bulloni_cerchione_destro_posteriore");
  set_attribute(bulloni_cerchione_destro_posteriore, obsGlass);

  bulloni_cerchione_sinistro_anteriore = read_obj("bulloni_cerchione_sinistro_anteriore.obj", "bulloni_cerchione_sinistro_anteriore");
  set_attribute(bulloni_cerchione_sinistro_anteriore, obsGlass);

  bulloni_cerchione_sinistro_posteriore = read_obj("bulloni_cerchione_sinistro_posteriore.obj", "bulloni_cerchione_sinistro_posteriore");
  set_attribute(bulloni_cerchione_sinistro_posteriore, obsGlass);

  pinza_disco_freno_destro_anteriore = read_nurbs("pezzo14_dxa.db");
  set_attribute(pinza_disco_freno_destro_anteriore, blu);

  pinza_disco_freno_destro_posteriore = read_nurbs("pezzo14_dxp.db");
  set_attribute(pinza_disco_freno_destro_posteriore, blu);
  
  pinza_disco_freno_sinistro_anteriore = read_nurbs("pezzo14_sxa.db");
  set_attribute(pinza_disco_freno_sinistro_anteriore, blu);

  pinza_disco_freno_sinistro_posteriore = read_nurbs("pezzo14_sxp.db");
  set_attribute(pinza_disco_freno_sinistro_posteriore, blu);

  pneumatico_destro_anteriore = read_nurbs("pneumatico_dxa.db");  
  //set_attribute(pneumatico_destro_anteriore, nero);
  set_bump_texture(pneumatico_destro_anteriore, nero, "textures/gomma.hr", 0, 1, 0, 0.1, TRUE, 0.5, 0.5);

  pneumatico_destro_posteriore = read_nurbs("pneumatico_dxp.db");  
  //set_attribute(pneumatico_destro_posteriore, nero);
  set_bump_texture(pneumatico_destro_posteriore, nero, "textures/gomma.hr", 0, 1, 0, 0.1, TRUE, 0.5, 0.5);
  
  pneumatico_sinistro_anteriore = read_nurbs("pneumatico_sxa.db");  
  //set_attribute(pneumatico_destro_anteriore, nero);
  set_bump_texture(pneumatico_sinistro_anteriore, nero, "textures/gomma.hr", 0, 1, 0, 0.1, TRUE, 0.5, 0.5);
  
  pneumatico_sinistro_posteriore = read_nurbs("pneumatico_sxp.db");  
  //set_attribute(pneumatico_destro_posteriore, nero);
  set_bump_texture(pneumatico_sinistro_posteriore, nero, "textures/gomma.hr", 0, 1, 0, 0.1, TRUE, 0.5, 0.5);
  
  griglia_anteriore_fari = read_nurbs("griglia_cofano_fari.db"); 
  set_domain_texture(griglia_anteriore_fari, nero, "textures/griglia_.hr", 0, 1, 0, 0.5, TRUE, 0.2, 0.2);  

  griglia_paraurti_anteriore_sotto = read_nurbs("griglia_paraurti_anteriore_sotto.db"); 
  set_domain_texture(griglia_paraurti_anteriore_sotto, nero, "textures/griglia_.hr", 0, 1, 0, 0.5, TRUE, 0.2, 0.2);  
  
  fari_anteriori = read_obj("fari_anteriori.obj","fari_anteriori");
  set_attribute(fari_anteriori, steel);
  
  vetri_fari_anteriori = read_obj("vetri_fari_anteriori.obj","vetri_fari_anteriori");
  set_attribute(vetri_fari_anteriori, bianco);

  frecce = read_obj("frecce.obj","frecce");
  set_attribute(frecce, arancio);

  marmitte =  read_obj("marmitte.obj","marmitte");
  set_attribute(marmitte, steel);
 
  targa = read_nurbs("targa.db");  
  //set_attribute(targa, grigio);
  set_domain_texture(targa, nero, "textures/targa.hr", 1, 0, 1, 0, FALSE, 0.5, 0.5);  
  
  stemma = read_nurbs("stemma_posteriore.db");  
  set_attribute(stemma, steel); 
  //set_domain_texture(stemma, nero, "stemma.hr", 1, 0, 1, 0, FALSE, 0.5, 0.5);  

  strada = read_nurbs("strada.db");  
  //set_attribute(strada, grigio); 
  set_projection_texture(strada, grigio, "textures/asfalto01.hr", 2, TRUE, 0.4, 0.4);
   
  parcheggi = read_nurbs("parcheggi.db");  
  //set_attribute(strada, grigio); 
  set_projection_texture(parcheggi, grigio, "textures/asfalto01.hr", 2, TRUE, 0.4, 0.4);
  
  muretto = read_nurbs("muretto.db");  
  //set_attribute(strada, grigio); 
  set_domain_texture(muretto, grigio, "textures/muro.hr", 0, 0.1, 0, 0.4, TRUE, 0.5, 0.5);
  
  prato = read_obj("prato.obj","prato");
  //set_attribute(prato, verde);
  set_projection_texture(prato, verde, "textures/grass_ande.hr", 2, TRUE, 0.4, 0.4);
 

  scene = create_list(carrozzeria, "scene");
  scene = insert_in_list(scene, interni);
  scene = insert_in_list(scene, vetri);
  scene = insert_in_list(scene, pezzi_neri);
  scene = insert_in_list(scene, specchio_sx);
  scene = insert_in_list(scene, specchio_dx);
  scene = insert_in_list(scene, pezzi_rossi);
  scene = insert_in_list(scene, cerchio_completo_destro_anteriore);
  scene = insert_in_list(scene, cerchio_completo_destro_posteriore);
  scene = insert_in_list(scene, cerchio_completo_sinistro_anteriore);
  scene = insert_in_list(scene, cerchio_completo_sinistro_posteriore);
  scene = insert_in_list(scene, pneumatico_destro_anteriore);
  scene = insert_in_list(scene, pneumatico_destro_posteriore);
  scene = insert_in_list(scene, pneumatico_sinistro_anteriore);
  scene = insert_in_list(scene, pneumatico_sinistro_posteriore);
  scene = insert_in_list(scene, bulloni_cerchione_destro_anteriore);
  scene = insert_in_list(scene, bulloni_cerchione_destro_posteriore); 
  scene = insert_in_list(scene, bulloni_cerchione_sinistro_anteriore);
  scene = insert_in_list(scene, bulloni_cerchione_sinistro_posteriore);
  scene = insert_in_list(scene, pinza_disco_freno_destro_anteriore);
  scene = insert_in_list(scene, pinza_disco_freno_destro_posteriore);
  scene = insert_in_list(scene, pinza_disco_freno_sinistro_anteriore);
  scene = insert_in_list(scene, pinza_disco_freno_sinistro_posteriore);
  scene = insert_in_list(scene, fari_anteriori);
  scene = insert_in_list(scene, griglia_anteriore_fari);
  scene = insert_in_list(scene, griglia_paraurti_anteriore_sotto);
  scene = insert_in_list(scene, vetri_fari_anteriori);
  scene = insert_in_list(scene, frecce);
  scene = insert_in_list(scene, marmitte);
  scene = insert_in_list(scene, targa);
  scene = insert_in_list(scene, stemma);
  scene = insert_in_list(scene, strada);
  scene = insert_in_list(scene, parcheggi);
  scene = insert_in_list(scene, muretto);
  scene = insert_in_list(scene, prato);
  save_scene("mustang.md","scene_mustang",scene);
  return(0);
}
